Attribute VB_Name = "mdlPath"
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

Option Explicit

Public Declare Function SHGetPathFromIDList Lib "shell32.dll" _
        Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal _
        pszPath As String) As Long
        
Public Declare Function SHGetSpecialFolderLocation Lib _
        "shell32.dll" (ByVal hwndOwner As Long, ByVal nFolder _
        As Long, pidl As ITEMIDLIST) As Long
        
Public Declare Function GetTempPath Lib "kernel32" Alias _
        "GetTempPathA" (ByVal nBufferLength As Long, ByVal _
        lpBuffer As String) As Long
        
Public Type ITEMID
    cb As Long
    abID As Byte
End Type

Public Type ITEMIDLIST
    mkid As ITEMID
End Type

Public Const CSIDL_FLAG_CREATE As Long = &H8000

Public Const CSIDL_ADMINTOOLS As Long = &H30
Public Const CSIDL_ALTSTARTUP As Long = &H1D

' Anwendungsdaten
Public Const CSIDL_APPDATA As Long = &H1A

Public Const CSIDL_BITBUCKET As Long = &HA

' CD Burning
Public Const CSIDL_CDBURN_AREA As Long = &H3B

' Fr alle Benutzer (All Users)
Public Const CSIDL_COMMON_ADMINTOOLS As Long = &H2F
Public Const CSIDL_COMMON_ALTSTARTUP As Long = &H1D
Public Const CSIDL_COMMON_APPDATA As Long = &H23

' Desktop
Public Const CSIDL_COMMON_DESKTOPDIRECTORY As Long = &H19

Public Const CSIDL_COMMON_DOCUMENTS As Long = &H2E

' Favoriten
Public Const CSIDL_COMMON_FAVORITES As Long = &H1F

' Gemeinsame Musik
Public Const CSIDL_COMMON_MUSIC As Long = &H35

' Gemeinsame Bilder
Public Const CSIDL_COMMON_PICTURES As Long = &H36

' Programme-Ordner im Startmen
Public Const CSIDL_COMMON_PROGRAMS As Long = &H17

' Starmen
Public Const CSIDL_COMMON_STARTMENU As Long = &H16

' Autostart
Public Const CSIDL_COMMON_STARTUP As Long = &H18

' Vorlagen
Public Const CSIDL_COMMON_TEMPLATES As Long = &H2D

' Gemeinsame Videos
Public Const CSIDL_COMMON_VIDEO As Long = &H37



Public Const CSIDL_CONTROLS As Long = &H3

' Cookies
Public Const CSIDL_COOKIES As Long = &H21

' Desktop
Public Const CSIDL_DESKTOP As Long = &H0
Public Const CSIDL_DESKTOPDIRECTORY As Long = &H10

' Treiber
Public Const CSIDL_DRIVES As Long = &H11

' Favoriten
Public Const CSIDL_FAVORITES As Long = &H6

' Schriftarten
Public Const CSIDL_FONTS As Long = &H14

' Verlauf
Public Const CSIDL_HISTORY As Long = &H22

Public Const CSIDL_INTERNET As Long = &H1

' Temporre Internetdateien
Public Const CSIDL_INTERNET_CACHE As Long = &H20

' Anwendungsdaten
Public Const CSIDL_LOCAL_APPDATA As Long = &H1C

Public Const CSIDL_MYDOCUMENTS As Long = &HC

' Eigene Musik
Public Const CSIDL_MYMUSIC As Long = &HD

' Eigene Bilder
Public Const CSIDL_MYPICTURES As Long = &H27

' Eigene Videos
Public Const CSIDL_MYVIDEO As Long = &HE

' Netzwerkumgebung
Public Const CSIDL_NETHOOD As Long = &H13

Public Const CSIDL_NETWORK As Long = &H12

' Eigene Dateien
Public Const CSIDL_PERSONAL As Long = &H5

Public Const CSIDL_PRINTERS As Long = &H4

' Druckerumgebung
Public Const CSIDL_PRINTHOOD As Long = &H1B

' Profil
Public Const CSIDL_PROFILE As Long = &H28

' Programme
Public Const CSIDL_PROGRAM_FILES As Long = &H26

' Gemeinsamme Dateien
Public Const CSIDL_PROGRAM_FILES_COMMON As Long = &H2B

' Programme (im Startmen)
Public Const CSIDL_PROGRAMS As Long = &H2

' Zuletzt verwendete Dokumente
Public Const CSIDL_RECENT As Long = &H8

' Senden An
Public Const CSIDL_SENDTO As Long = &H9

' Startmen
Public Const CSIDL_STARTMENU As Long = &HB

' Autostart
Public Const CSIDL_STARTUP As Long = &H7

' System (bzw. System32)
Public Const CSIDL_SYSTEM As Long = &H25

' Vorlagen
Public Const CSIDL_TEMPLATES As Long = &H15

' Windows
Public Const CSIDL_WINDOWS As Long = &H24

Public Const NOERROR As Long = 0&

'**********************************************************

Public Declare Function LockWindowUpdate Lib "user32" _
        (ByVal hwndLock As Long) As Long
        
Public Declare Function GetDesktopWindow Lib "user32" _
        () As Long

Public Sub Freeze()
'Fenster einfrieren
  LockWindowUpdate (GetDesktopWindow)
End Sub

Public Sub Defrost()
'Fenster wieder normal anzeigen
  LockWindowUpdate (0&)
End Sub

'**********************************************************

Public Function GetPath(Num As Long) As String
    Dim Result As Long
    Dim Buff As String
    Dim idl As ITEMIDLIST
   
    Result = SHGetSpecialFolderLocation(frmPlayer.hwnd, Num, idl)
    If Result = NOERROR Then
        Buff = Space$(512)
        Result = SHGetPathFromIDList(ByVal idl.mkid.cb, ByVal Buff)
        If Result Then GetPath = Trim$(Buff)
    End If
End Function

